module Validocno
  class Validator

    CONTROL_URI = "https://www2.politsei.ee/qr/".freeze

    def initialize(doc_number)
      @doc_number = doc_number
    end

    def response_string
      response = RestClient.get(CONTROL_URI, :params => { :qr => @doc_number })
      check_response(response)

      document = Nokogiri::HTML(response)

      node = document.at_css(".qrWidgetDocumentCheckResult")

      if node.nil? || node.children.empty?
        fail StandardError, 'Cannot parse document status string.'
      else
        node.children.at_css("div").text.strip
      end
    end

    def validate
      response_string_result = response_string
      is_valid = response_string_result == response_strings[:valid]

      {
        :valid => is_valid,
        :message => response_string_result
      }
    end

    def response_strings
      {
        :valid => "Dokument #{@doc_number} on kehtiv.",
        :expired => "Dokument #{@doc_number} on kehtetu.",
        :invalid => "Dokumenti #{@doc_number} ei ole välja antud."
      }
    end

    def check_response(response)
      return true if response.code == 200
      fail StandardError, "#{response.code}: #{response.message}"
    end
  end
end
